(define (make-generator value)
  (define yield (lambda (x) x))

  (define (state)
    (let loop ((value value))
      (when (>= value 0)
        (call/cc (lambda (h)
                   (set! state h)
                   (yield value)))
        (loop (- value 1))))
    (yield #!null))

  (define (generator)
    (call/cc (lambda (self)
               (set! yield self)
               (state))))
  generator)

(define-simple-class Generator2 (java.util.function.Supplier)
  (gen init-form: (make-generator 10000))
  ((get)
   (gen)))
